/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: t_iabs.c,v 1.2 1997/09/25 18:14:25 ae59 Exp $ */
/*
$Log: t_iabs.c,v $
 * Revision 1.2  1997/09/25  18:14:25  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:25:25  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : t_iabs.c                              */
/*                                                              */
/*      Date            : 1991-11-14                            */
/*      1991-11-14 : save and restore flags                     */
/*      1991-09-24 : macro call StdFctReal replaced             */
/*      1991-09-17 : remove semicolon after makro               */
/*      1991-08-05 : remove unused variables absl,absu          */
/*      1991-06-21 : new routine                                */
/****************************************************************/

#ifdef AIX
#include "/u/p88c/runtime/tbyte/t_defs.h"
#else
#include "t_defs.h"
#endif

/* StdFctReal(t_abs, absee) */
#ifdef LINT_ARGS
a_real t_abs(a_real arg)
#else
a_real t_abs(arg)

a_real arg;
#endif
        {
        int      rnd, rc;
        a_real   res;
        ExtReal  a, r;

        E_SPUSH("t_abs")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&arg, &a);

        if ((rc = absee(&a, &r))!=0
            || (rc = extreal_to_longreal(&r, (LongReal *)&res))!=0)
           ieee_abortr1(rc, &arg);

        setrndmode(rnd);

        E_SPOPP("t_abs")
        return res;
        }

/* StdFctInterval(t_iabs,iabsee) */
#ifdef LINT_ARGS
a_intv t_iabs(a_intv ai)
#else
a_intv t_iabs(ai)

a_intv ai;
#endif
        {

        a_intv   res;
        int      rnd, rc;
        IExtReal  a, r;

        E_SPUSH("t_iabs")

        rnd = getrndmode();
        longreal_to_extreal((LongReal *)&ai.INF, &a.l);
        longreal_to_extreal((LongReal *)&ai.SUP, &a.u);

        if ((rc = iabsee(&a, &r))!=0)
            ieee_aborti1(rc, &ai);

        setrndmode(DOWN);
        if ((rc = extreal_to_longreal(&r.l, (LongReal *)&res.INF))!=0)
             ieee_aborti1(rc, &ai);
        setrndmode(UP);
        if ((rc = extreal_to_longreal(&r.u, (LongReal *)&res.SUP))!=0)
            ieee_aborti1(rc, &ai);
        setrndmode(rnd);

        E_SPOPP("t_iabs")
        return res;
        }

/*--------------------------------------------------------------*
 | iabsee                                                       |
 *--------------------------------------------------------------*/
/*
**  geaendert 030990 Baumhof:
**  iabsee berechnete das Intervall von |arg.l| bis |arg.u|,
**  geaendert, so dass {|x|: x in arg} zurueckgegeben wird.
*/
#ifdef ANSI_C
#ifdef LINT_ARGS
int iabsee (const IExtReal *arg, IExtReal *res)
#else
int iabsee (arg, res)
const IExtReal  *arg;
      IExtReal  *res;
#endif /* LINT_ARGS */
#else  /* NOT ANSI_C */
#ifdef LINT_ARGS
int iabsee (IExtReal *arg, IExtReal *res)
#else
int iabsee (arg, res)
IExtReal  *arg;
IExtReal  *res;
#endif /* LINT_ARGS */
#endif /* ANSI_C */
{
   int   ret;

   if (cmpee(&Zero, &(arg->l)) <= 0)            /* arg.l >= 0 */
   {
      ret  = absee(&(arg->u), &(res->u));
      ret += absee(&(arg->l), &(res->l));
   }
   else if (cmpee(&Zero, &(arg->u)) >= 0)       /* arg.u <= 0 */
   {
      ret  = absee(&(arg->u), &(res->l));
      ret += absee(&(arg->l), &(res->u));
   }
   else                                  /* arg.l < 0 < arg.u */
   {
      if (cmpabsee(&(arg->u), &(arg->l)) >= 0)  /* |u| >= |l| */
         ret = absee(&(arg->u), &(res->u));
      else
         ret = absee(&(arg->l), &(res->u));
      copyee(&Zero, &(res->l));
   }

   return ret;
} /* iabsee() */
